


//#include <ilcplex/ilocplex.h>
//#include "main.h"

#ifndef _CLASS_POLYHEDRON_SET
#define _CLASS_POLYHEDRON_SET

// #include <ppl.hh>
// #include <stdio.h>
// #include <iostream>
#include "DHR_Rational.h"

using namespace Parma_Polyhedra_Library;
using namespace Parma_Polyhedra_Library::IO_Operators;
using namespace std;


class DHR_PolyhedronSet
{
	public:
	DHR_PolyhedronSet();
	~DHR_PolyhedronSet();
	void resetReachableAll();
	void resetReachableFlag();
	void setReachable();
	void setReachable(int);
	void countReachable();
	void add(C_Polyhedron*, DHR_Rational**, DHR_Rational*);
	void add_convex_hull(C_Polyhedron*, DHR_Rational**, DHR_Rational*);
	int getSize();
	int getSize(int);
	void display();
	void displayFloat(ofstream &);
	void computeRanges(DHR_Rational**, DHR_Rational*);
	void interpretAsRange(DHR_Rational, DHR_Rational, DHR_Rational, DHR_Rational);
	//private:
	//int numberSplitLocation;
	C_Polyhedron* polyhedron;
	DHR_Rational** sizeRange;
	DHR_Rational maxSizeRange;
	bool reachable;
	int reachableCount;
	DHR_PolyhedronSet* next;

};

#endif

DHR_PolyhedronSet* intersectionPolyhedronSet(DHR_PolyhedronSet*, DHR_PolyhedronSet*);
bool nonSingularIntersection(C_Polyhedron*, C_Polyhedron*);
bool nonEmptyIntersection(C_Polyhedron*, C_Polyhedron*);
C_Polyhedron* readPolyhedron(ifstream&, char*);




